/*!
 * module-loader.js v0.0.13
 * (c) 2014-2020 stwilson
 * Released under the MIT License.
 */
export { to as catchWrap } from 'await-to-js';
import { Types, typeCheckExpression, getUniqueKey } from '@blocks-framework/core';
export * from '@blocks-framework/core';
import { Component as Component$1, Prop, Vue } from 'vue-property-decorator';
export { Prop, Watch } from 'vue-property-decorator';

//same to vue-class-component
var $internalHooks = [
    'data',
    'beforeCreate',
    'created',
    'beforeMount',
    'mounted',
    'beforeDestroy',
    'destroyed',
    'beforeUpdate',
    'updated',
    'activated',
    'deactivated',
    'render',
    'errorCaptured',
    'serverPrefetch' // 2.6
];
var Component = function (options) {
    return ComponentFactory(Component$1, options);
};
function ComponentFactory(oldComponentFactory, options) {
    if (typeof options === 'function') {
        var extendOptions = handleExtendController(options, {});
        var comFun = oldComponentFactory(extendOptions);
        var com = comFun(options);
        // com.options.type = options;
        return com;
    }
    return function (Component) {
        handleExtendController(Component, options);
        var com = oldComponentFactory(options);
        var comObj = com(Component);
        if (typeof Component === 'function')
            //   comObj.options.type = options;
            return comObj;
    };
}
function handleExtendController(oldComponentFactory, options) {
    var baseController = oldComponentFactory.prototype.__proto__;
    Object.getOwnPropertyNames(baseController).forEach(function (key) {
        if ($internalHooks.indexOf(key) > -1) {
            options[key] = baseController[key];
            return;
        }
    });
    return options;
}
// import { Component } from 'vue-property-decorator';
// export { Component }

/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */
/* global Reflect, Promise */

var extendStatics = function(d, b) {
    extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return extendStatics(d, b);
};

function __extends(d, b) {
    extendStatics(d, b);
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
}

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function __spreadArrays() {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
}

var isPromise = function (obj) {
    return !!obj && (typeof obj === 'object' || typeof obj === 'function') && typeof obj.then === 'function';
};

var INJECTION = Symbol.for("INJECTION");
function _proxyGetter(proto, key, resolve, doCache) {
    function getter() {
        //let that:any = this;
        if (doCache && !Reflect.hasMetadata(INJECTION, this, key)) {
            Reflect.defineMetadata(INJECTION, resolve(), this, key);
        }
        if (Reflect.hasMetadata(INJECTION, this, key)) {
            return Reflect.getMetadata(INJECTION, this, key);
        }
        else {
            return resolve();
        }
    }
    function setter(newVal) {
        Reflect.defineMetadata(INJECTION, newVal, this, key);
    }
    Object.defineProperty(proto, key, {
        configurable: true,
        enumerable: true,
        get: getter,
        set: setter
    });
}
function makePropertyInjectDecorator(containerFunc, doCache) {
    return function (serviceIdentifier) {
        return function (proto, key) {
            var resolve = function () {
                return containerFunc().get(serviceIdentifier);
            };
            _proxyGetter(proto, key, resolve, doCache);
        };
    };
}
function makePropertyInjectNamedDecorator(containerFunc, doCache) {
    return function (serviceIdentifier, named) {
        return function (proto, key) {
            var resolve = function () {
                return containerFunc().getNamed(serviceIdentifier, named);
            };
            _proxyGetter(proto, key, resolve, doCache);
        };
    };
}
function makePropertyInjectTaggedDecorator(containerFunc, doCache) {
    return function (serviceIdentifier, key, value) {
        return function (proto, propertyName) {
            var resolve = function () {
                return containerFunc().getTagged(serviceIdentifier, key, value);
            };
            _proxyGetter(proto, propertyName, resolve, doCache);
        };
    };
}
function makePropertyMultiInjectDecorator(containerFunc, doCache) {
    return function (serviceIdentifier) {
        return function (proto, key) {
            var resolve = function () {
                return containerFunc().getAll(serviceIdentifier);
            };
            _proxyGetter(proto, key, resolve, doCache);
        };
    };
}

function getDecorators(containerFunc, doCache) {
    if (doCache === void 0) { doCache = true; }
    var lazyInject = makePropertyInjectDecorator(containerFunc, doCache);
    var lazyInjectNamed = makePropertyInjectNamedDecorator(containerFunc, doCache);
    var lazyInjectTagged = makePropertyInjectTaggedDecorator(containerFunc, doCache);
    var lazyMultiInject = makePropertyMultiInjectDecorator(containerFunc, doCache);
    return {
        lazyInject: lazyInject,
        lazyInjectNamed: lazyInjectNamed,
        lazyInjectTagged: lazyInjectTagged,
        lazyMultiInject: lazyMultiInject
    };
}

var InjectModel = /** @class */ (function () {
    function InjectModel() {
        this.Conainter = undefined;
    }
    return InjectModel;
}());
var InjectCore = new InjectModel();
var SpecialInject = getDecorators(function () {
    if (InjectCore.Conainter === undefined)
        throw new Error("InjectCore.Conainter is undefined.");
    return InjectCore.Conainter;
});

var Controller = /** @class */ (function (_super) {
    __extends(Controller, _super);
    function Controller() {
        var _this_1 = _super !== null && _super.apply(this, arguments) || this;
        // constructor() {
        //     super();
        //     // if(!InjectCore.Conainter)
        //     //     throw new Error("InjectCore.Conainter canot be null.")
        //     // this.resourceManager = InjectCore.Conainter.get<IResourceManager>(Types.IResourceManager);
        //     // this.blocksShell =  InjectCore.Conainter.get<IBlocksShell>(Types.IBlocksShell);
        //     // this.routeManager =  InjectCore.Conainter.get<IRouteManager>(Types.IRouteManager);
        // }
        _this_1.UniqueKey = "";
        _this_1.switchMode = 0;
        return _this_1;
    }
    Controller.prototype.created = function () {
        this.$emit("beforeViewWillEnter", this);
        this.viewWillEnterResult = this.viewWillEnter();
        console.log("assign viewWillEnterResult");
        if ((typeof this.UniqueKey === "undefined" || this.UniqueKey === "") && this.$route && this.$route.meta && this.$route.meta.uniqueKey) {
            this.UniqueKey = this.$route.meta.uniqueKey;
        }
    };
    Controller.prototype.mounted = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this_1 = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.$emit("ViewDidEnterStart", this);
                        if (!isPromise(this.viewDidEnter)) return [3 /*break*/, 2];
                        this.viewDidEnterResult = this.viewDidEnter();
                        return [4 /*yield*/, this.viewDidEnterResult];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 3];
                    case 2:
                        this.viewDidEnter();
                        _a.label = 3;
                    case 3:
                        this.viewAnimationEndTime = setTimeout(function () {
                            _this_1.viewAnimationEnd();
                        }, 800);
                        return [2 /*return*/];
                }
            });
        });
    };
    Controller.prototype.beforeMount = function () {
        this.$emit("beforeViewDidEnter", this);
        this.beforeViewDidEnter();
    };
    Controller.prototype.beforeViewDidEnter = function () {
    };
    Controller.prototype.viewAnimationEndAndDataReady = function () {
    };
    Controller.prototype.viewAnimationEnd = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _this;
            var _this_1 = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.debug("viewAnimationEnd start");
                        clearTimeout(this.viewAnimationEndTime);
                        if (!isPromise(this.viewWillEnterResult)) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.viewWillEnterResult];
                    case 1:
                        _a.sent();
                        console.debug("await  viewWillEnterResult");
                        _a.label = 2;
                    case 2:
                        console.debug("viewWillEnterResult end");
                        if (!isPromise(this.viewAnimationEndAndDataReady)) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.viewAnimationEndAndDataReady()];
                    case 3:
                        _a.sent();
                        return [3 /*break*/, 5];
                    case 4:
                        this.viewAnimationEndAndDataReady();
                        _a.label = 5;
                    case 5:
                        if (!isPromise(this.viewDidEnterResult)) return [3 /*break*/, 7];
                        return [4 /*yield*/, this.viewDidEnterResult];
                    case 6:
                        _a.sent();
                        console.debug("await  viewDidEnterResult");
                        _a.label = 7;
                    case 7:
                        console.debug("viewAnimationEndAndDataReady end");
                        _this = this;
                        _this.$emit("viewDataReadyFinish");
                        _this.$nextTick(function () { return __awaiter(_this_1, void 0, void 0, function () {
                            var allCom, _i, allCom_1, com, comChild;
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0:
                                        if (!_this.$el.querySelectorAll) return [3 /*break*/, 4];
                                        allCom = _this.$el.querySelectorAll(".vue-recycle-scroller__item-view");
                                        _i = 0, allCom_1 = allCom;
                                        _a.label = 1;
                                    case 1:
                                        if (!(_i < allCom_1.length)) return [3 /*break*/, 4];
                                        com = allCom_1[_i];
                                        comChild = com.firstElementChild;
                                        if (!(comChild && comChild.componentOnReady)) return [3 /*break*/, 3];
                                        return [4 /*yield*/, comChild.componentOnReady()];
                                    case 2:
                                        _a.sent();
                                        _a.label = 3;
                                    case 3:
                                        _i++;
                                        return [3 /*break*/, 1];
                                    case 4:
                                        _this.$emit("viewReaderFinish", _this);
                                        return [2 /*return*/];
                                }
                            });
                        }); });
                        return [2 /*return*/];
                }
            });
        });
    };
    Controller.prototype.viewWillEnter = function () {
    };
    Controller.prototype.viewDidEnter = function () {
    };
    Controller.prototype.switch = function (switchUniqueKey, switchParams) {
        return __awaiter(this, void 0, void 0, function () {
            var routeManager, uniqueKey, route, _i, _a, layoutRoutes, dialogParams, dialog, routeReslove_1, routeReject_1, routePushPromise;
            var _this_1 = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (typeof switchParams === undefined || switchParams === null || typeof switchUniqueKey === undefined || switchUniqueKey.uniqueKey === null)
                            throw new Error("switchParams must contains uniqueKey.");
                        routeManager = this.routeManager;
                        if (routeManager === undefined)
                            throw new Error("routeManager is undefined.");
                        uniqueKey = switchUniqueKey.moduleName ? getUniqueKey(switchUniqueKey.moduleName, switchUniqueKey.uniqueKey) :
                            getUniqueKey(this.getModuleName(), switchUniqueKey.uniqueKey);
                        for (_i = 0, _a = routeManager.getRoute(); _i < _a.length; _i++) {
                            layoutRoutes = _a[_i];
                            if (layoutRoutes.children === undefined || layoutRoutes.children === null)
                                continue;
                            route = layoutRoutes.children.find(function (r) { return r.uniqueKey === uniqueKey; });
                            if (route)
                                break;
                        }
                        if (!(this.switchMode === 0)) return [3 /*break*/, 3];
                        dialogParams = Object.assign(true, {
                            component: route.component,
                        }, switchParams);
                        dialogParams.componentProps = Object.assign({ UniqueKey: uniqueKey }, dialogParams.componentProps);
                        return [4 /*yield*/, this.$dialog.create(dialogParams)];
                    case 1:
                        dialog = _b.sent();
                        return [4 /*yield*/, dialog.present()];
                    case 2: return [2 /*return*/, _b.sent()];
                    case 3:
                        routePushPromise = new Promise(function (resolve, reject) {
                            routeReslove_1 = resolve;
                            routeReject_1 = reject;
                        });
                        this.$router.push({ name: route.name }, function () {
                            routeReslove_1({
                                onDidDismiss: new Promise(function (resolve, reject) {
                                    _this_1.switchResolve = resolve;
                                })
                            });
                        }, function () {
                            routeReject_1();
                        });
                        return [4 /*yield*/, routePushPromise];
                    case 4: return [2 /*return*/, _b.sent()];
                }
            });
        });
    };
    Controller.prototype.exit = function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        if (this.switchMode === 0) {
            this.$emit.apply(this, __spreadArrays(["exit"], args));
        }
        else {
            if (this.switchResolve) {
                this.switchResolve();
            }
        }
    };
    Controller.prototype.getModuleName = function () {
        var shell = this.blocksShell; //globalIocManager.get<IBlocksShell>(Types.IBlocksShell);
        if (shell === undefined)
            throw new Error("shell is undefined.");
        if (this.$options._Ctor === undefined)
            throw new Error("$options._Ctor is undefined.");
        //let moduleName = shell.typeMapModuleName.get(this.constructor);
        var moduleName = shell.typeMapModuleName.get(this.$options._Ctor[0]);
        if (moduleName === undefined)
            throw new Error(this + " not belong to framework.");
        return moduleName;
    };
    Controller.prototype.getResources = function (moduleName, resourceType, resourceName) {
        if (this.resourceManager === undefined)
            throw new Error("resourceManager is undefined.");
        var resourceDef = this.resourceManager.getResource(moduleName, resourceType, resourceName);
        if (resourceDef === undefined)
            throw new Error("Can not found resourceType:" + resourceType + ", resourceName:" + resourceName + " in resources.");
        return resourceDef.resource;
    };
    __decorate([
        Prop({ type: String, default: "" }),
        __metadata("design:type", String)
    ], Controller.prototype, "UniqueKey", void 0);
    __decorate([
        SpecialInject.lazyInject(Types.IResourceManager),
        __metadata("design:type", Object)
    ], Controller.prototype, "resourceManager", void 0);
    __decorate([
        SpecialInject.lazyInject(Types.IBlocksShell),
        __metadata("design:type", Object)
    ], Controller.prototype, "blocksShell", void 0);
    __decorate([
        SpecialInject.lazyInject(Types.IRouteManager),
        __metadata("design:type", Object)
    ], Controller.prototype, "routeManager", void 0);
    return Controller;
}(Vue));
typeCheckExpression.push(function (exportType, fileKey) {
    if (!fileKey.endsWith("bl"))
        return;
    return exportType;
    // if (exportType.prototype instanceof Controller && exportType.options.type)
    //     return exportType.options.type;
});

function asyncCompatible() {
    return function (target, propertyKey, descriptor) {
        var originFunc = descriptor.value;
        descriptor.value = function () {
            var param = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                param[_i] = arguments[_i];
            }
            return __awaiter(this, void 0, void 0, function () {
                var paramLength, actParam, p, returnObj, hasThen, result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            paramLength = param.length;
                            actParam = paramLength > 1 ? param.slice(0, paramLength) : param;
                            p = paramLength > 0 ? param[paramLength - 1] : null;
                            returnObj = originFunc.call.apply(originFunc, __spreadArrays([this], actParam));
                            hasThen = true;
                            try {
                                hasThen = returnObj.then !== "undefined";
                            }
                            catch (error) {
                                hasThen = false;
                            }
                            if (!hasThen) return [3 /*break*/, 5];
                            _a.label = 1;
                        case 1:
                            _a.trys.push([1, , 3, 4]);
                            return [4 /*yield*/, returnObj];
                        case 2:
                            result = _a.sent();
                            return [3 /*break*/, 4];
                        case 3:
                            p && p(result);
                            return [7 /*endfinally*/];
                        case 4: return [3 /*break*/, 6];
                        case 5:
                            p && p(returnObj);
                            _a.label = 6;
                        case 6: return [2 /*return*/];
                    }
                });
            });
        };
    };
}

export { Component, Controller, InjectCore, SpecialInject, asyncCompatible };
